#!/usr/bin/env perl

use strict ;
use warnings ;
use Term::ReadKey ;
use IO::Socket ;

my ($host, $port, $kidpid, $handle, $line);

($host, $port) = ('147.46.42.110','46804') ;

my $prompt = "STP) " ;
my $outputdir = "." ;

my $login = 0 ;

$handle = IO::Socket::INET->new(Proto     => "tcp",
                                PeerAddr  => $host,
                                PeerPort  => $port)
       or die "can't connect to port $port on $host: $!";

$handle->autoflush(1) ;

print STDERR "[Connected to $host:$port]\n" ;

if (1){
	#main
	&receiver() ;
	print STDERR "$prompt" ;
    while (defined ($line = <STDIN>)) {
		chomp($line) ;
		&splitResp($handle,$line) ;
		print STDERR "$prompt" ;
    }
}

exit;

sub splitResp {
	my ($handle,$input)=@_;
	if(my ($linuxCmd) = $input =~ m{^\s*!(.*)}){
		system(join(" ","$linuxCmd"));
	}elsif(my ($inputpath) = $input =~ m{^\s*input\s+(.+)$}i){
		&input($handle,$inputpath);
	}elsif( my ($OUTPUTDIR) = $input =~ m{^dir\s+(.+)}i){
		print "changed outputdir from [$outputdir] to " ;
		$outputdir = $OUTPUTDIR;
		print "[$outputdir]\n";
	}else{
		print $handle "$input\n" ;
		&receiver() ;
	}
}

sub input {
	my ($handle,$file)=@_;
	open(my $f,"<$file") or die "Error when read $file.";
	my @file = <$f>;
	close($f);
	foreach my $l (@file){
		chomp($l);
		&splitResp($handle,$l);
	}
}

sub receiver {
	while  ( defined( my $line = $handle->getline ) ) {
		if (my ($fname,$fsize) = $line =~ m{fn:(.+),fs:(\d+)$}){
			my $saccont ;
			if (not -e $outputdir){
				`mkdir -p $outputdir` ;
			}
			open my $fhsac, ">:raw", "$outputdir/$fname" ;
			my $success = read $handle, $saccont, $fsize, 0 ;
			die $! if not defined $success ;
			print $fhsac $saccont ;
			close($fhsac) ;
			print STDERR "saved: $outputdir/$fname\n" ;
		}elsif($line =~ m{showprompt$}){
			print STDERR "$prompt" ;
		}elsif($line =~ m{idrequest$}){
			print STDERR "id: " ;
			my $id = ReadLine 0;
			#my $id = "" ; #you can save id
			chomp($id) ;
			print $handle "$id\n" ;
		}elsif($line =~ m{pwrequest$}){
			ReadMode 'noecho' ;
			print STDERR "pw: " ;
			my $pw = ReadLine 0;
			#my $pw = "" ; #you can save pw
			ReadMode 'normal' ;
			chomp($pw) ;
			print $handle "$pw\n" ;
		}elsif($line =~ m{login$}){
			$login = 1 ;
		}elsif($line =~ m{imdone$}){
			goto done ;
		}else{
			chomp($line) ;
        	print STDERR "$line\n" ;
		}
    }
	done:
}

